/* ==============================================================================
   Programa principal:
   Laboratrio: 10 (Conj. Disjuntos)   
   Disciplina: MC202
   Data: 20 / 11 /2001
   =========================================================================== */

#include "cdisj.h"
#include <stdlib.h>
#include <stdio.h>
#include <malloc.h>

void Lelinha() {
    char c;
    do { scanf("%c", &c); } while (c !='\n');
  return;
}

int main(){
  Colecao C;
  int ExisteUmaColecao=0;
  int n, i, j;
  char acao, c;

  /* ----------------------------------------------------------------------------
     Declaraes e incio para verificao do uso da memria dinmica. 
     A varivel 'lixo' est sendo usada apenas para contornar um
     problema do funcionamento das funes da biblioteca 'malloc'. 
     A memria por ela apontada  desalocada logo a seguir!  
   ------------------------------------------------------------------------- */
  
  struct mallinfo info;   
  int MemDinInicial, MemDinFinal;
    
  void *lixo = malloc(1);   

  free(lixo);               
  info = mallinfo();
  MemDinInicial = info.uordblks;
   

  /* ----------------------------------------------------------------------- */  

  do {
    scanf("%c",&acao); 
    
    switch (acao) {
    case  'u':  
      if (!ExisteUmaColecao) 
	printf("Erro: no existe colecao para fazer unies\n"); 
      else{
	scanf("%d %d",&i,&j);
	Lelinha();
	printf("%d\n",Union(&C,Find(&C,i),Find(&C,j)));
      }
      break;

    case 'm':
      scanf("%d",&n);
      Lelinha();
      if (ExisteUmaColecao)
	Libera(&C);
      printf("%d\n",Makeset(&C,n));
      ExisteUmaColecao=1;
      break;

    case 'f':
      scanf("%d",&i);
      Lelinha();
      printf("%d\n",Find(&C,i));
      break;

    case 'p':
      if (!ExisteUmaColecao) 
	printf("Erro: no existe colecao para imprimir\n"); 
      else{
	Lelinha();
	printf("%d\n",NSets(&C));
      }
      break;

    case 'l':
      if (!ExisteUmaColecao) 
	printf("Erro: no existe colecao para liberar\n"); 
      else{
	Lelinha();
        Libera(&C);
      }
      break;

    case 's':
      if (!ExisteUmaColecao) 
	printf("Erro: no existe colecao para achar conjunto\n"); 
      else{
	scanf("%d",&i);
	Lelinha();
	printf("%d\n",NElems(&C,Find(&C,i)));
      }
      break;
      
    case 't': 
      Lelinha();
      printf("\n\nFim da execuo.\n\n");
      break;
      
    case '#': 
      scanf("%c", &c);
      while (c !='\n') { printf("%c",c);  scanf("%c", &c); } 
      printf("\n");
      break;      
      
    default:   printf("ao %c inexistente \n",acao);	
      Lelinha();
      break;  
    }
  } while (acao != 't');



/* --------------------------------------------------------------------------- */
/* Verificao final do uso da memria dinmica                                */
/* --------------------------------------------------------------------------- */
    
  info = mallinfo();
  MemDinFinal = info.uordblks;
  if (MemDinInicial!=MemDinFinal)
    printf("\n\nMemria dinmica no foi totalmente liberada (%d, %d)\n",
                      MemDinInicial,MemDinFinal);
   
/* --------------------------------------------------------------------------- */

  return 0;
} /* main */
